package com.oracle.coherence.handson;

import com.tangosol.net.CacheFactory;
import com.tangosol.net.NamedCache;
import com.tangosol.util.Filter;

import com.tangosol.util.aggregator.DoubleAverage;
import com.tangosol.util.aggregator.DoubleMax;
import com.tangosol.util.filter.EqualsFilter;

import com.tangosol.util.filter.AlwaysFilter;

public class AggregationExample {
    public AggregationExample() {
    }

    public static void main(String[] args) {
        Double averageAgeMales = null;
        Double averageAgeFemales = null;
        Double maxAge = null;
        Double averageAge = null;
        int max = 100;
        
        NamedCache person = CacheFactory.getCache("person");
        
        // create a new query 
        
     
          averageAgeMales = (Double)person.aggregate( 
                          new EqualsFilter("getGender",Person.MALE ),
                          new DoubleAverage("getAge")
                          );
                           
          averageAgeFemales = (Double)person.aggregate( 
                          new EqualsFilter("getGender",Person.FEMALE ),
                          new DoubleAverage("getAge")
                          );
        
          maxAge = (Double)person.aggregate( 
                          (Filter)null,   // new AlwaysFilter()
                          new DoubleMax("getAge")
                          );
        
          averageAge = (Double)person.aggregate( 
                          new AlwaysFilter(),
                          new DoubleAverage("getAge")
                          );
        
        
        
        System.out.println("Average age of males is " + averageAgeMales);
        System.out.println("Average age of females is " + averageAgeFemales);
        System.out.println("Max age is " + maxAge);
        System.out.println("Average age  " + averageAge);
    }
}
