package com.oracle.coherence.handson;

import com.tangosol.net.CacheFactory;
import com.tangosol.net.NamedCache;
import com.tangosol.util.Filter;

import com.tangosol.util.aggregator.DoubleAverage;
import com.tangosol.util.aggregator.DoubleMax;
import com.tangosol.util.filter.EqualsFilter;

import com.tangosol.util.filter.AlwaysFilter;

public class AggregationExampleWithTimings {
    public AggregationExampleWithTimings() {
    }

    public static void main(String[] args) {
        Double averageAgeMales = null;
        Double averageAgeFemales = null;
        Double maxAge = null;
        Double averageAge = null;
        int max = 100;
        
        NamedCache person = CacheFactory.getCache("person");
        long totalTime = 0;
        
        // create a new query 
        
       for (int i = 0; i< max; i++) {
          long startTime = System.currentTimeMillis();
        //    long startTime = System.nanoTime(); 
        //System.nanotime() is a new feature introduced in Java5 to give sub-millisecond measurements.


          averageAgeMales = (Double)person.aggregate( 
                          new EqualsFilter("getGender",Person.MALE ),
                          new DoubleAverage("getAge")
                          );
                           
          averageAgeFemales = (Double)person.aggregate( 
                          new EqualsFilter("getGender",Person.FEMALE ),
                          new DoubleAverage("getAge")
                          );
        
          maxAge = (Double)person.aggregate( 
                          (Filter)null,   // new AlwaysFilter()
                          new DoubleMax("getAge")
                          );
        
          averageAge = (Double)person.aggregate( 
                          new AlwaysFilter(),
                          new DoubleAverage("getAge")
                          );
        
        
         long endTime = System.currentTimeMillis();
         //long endTime = System.nanoTime(); 
        
         System.out.println("Total time taken is " + (endTime - startTime) / 1000F + " seconds");
         totalTime += (endTime - startTime);
        
       } 
        
        System.out.println("Average time is " +  (totalTime / max) / 1000F);
        
        //System.out.println("Average age of males is " + averageAgeMales);
        //System.out.println("Average age of females is " + averageAgeFemales);
        //System.out.println("Max age is " + maxAge);
        //System.out.println("Average age  " + averageAge);
    }
}
