package com.oracle.coherence.handson;

import com.tangosol.net.CacheFactory;
import com.tangosol.net.NamedCache;

import com.tangosol.util.extractor.ReflectionExtractor;

import java.io.IOException;

import java.util.Random;

public class PopulatePeople {
    public PopulatePeople() {
    }

    public static void main(String[] args) throws IOException {
                
        NamedCache person = CacheFactory.getCache("person");
        
        // add indexes
        person.addIndex(new ReflectionExtractor("getGender"), true, null);
        person.addIndex(new ReflectionExtractor("getAgeDouble"), false, null);
        
        Random generator = new Random();
        
        for (int i = 1; i <= 10000; i++) {
            Person p = new Person(i, "Surname" + i, "Firstname" + i,
                                  "Address" + i, generator.nextInt(100) + 1,
                                  (generator.nextInt(2) == 1 ? Person.FEMALE : Person.MALE) ) ;
            person.put(p.getId(),p);
    
        }
        
        System.out.println(person.entrySet().size());
        
    }
}
