package com.oracle.coherence.handson;

import com.tangosol.net.CacheFactory;
import com.tangosol.net.NamedCache;
import com.tangosol.util.AbstractMapListener;
import com.tangosol.util.MapEvent;
import com.tangosol.util.MapListener;
import com.tangosol.util.filter.EqualsFilter;
import com.tangosol.util.filter.MapEventFilter;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class ListenForUpdatedPerson {
    public ListenForUpdatedPerson() {
    }

    public static void main(String[] args) throws IOException {
        // connect to named cache
        NamedCache person = CacheFactory.getCache("person");
        
        // listen for insert events on Person
        // This can be done in an easier way by using a new AbstractMapListener()
        // and then overriding only the method you want to
        //
        person.addMapListener(new AbstractMapListener()
        {
              public void entryUpdated(MapEvent mapEvent) {
                Person oldPerson = (Person)mapEvent.getOldValue();
                 Person newPerson = (Person)mapEvent.getNewValue();
                 
                 // better to implement toString() on the person object to display it.. :)
                 System.out.println("Old person is " + oldPerson.getFirstname() + " " + 
                                    oldPerson.getSurname());
                 System.out.println("New person is " + newPerson.getFirstname() + " " + 
                             newPerson.getSurname());               
               }     
           },
          new MapEventFilter(MapEventFilter.E_UPDATED, new EqualsFilter("getGender", Person.MALE)),
          false   // not a lite event
                    
        );
        
        
        System.out.println("waiting for events");
        BufferedReader console = new BufferedReader(new InputStreamReader(System.in));
        String text = console.readLine();
        
      
    }
}
