package com.oracle.coherence.handson;

import com.tangosol.net.CacheFactory;
import com.tangosol.net.DistributedCacheService;
import com.tangosol.net.Member;
import com.tangosol.net.NamedCache;

import com.tangosol.util.filter.AlwaysFilter;

import java.util.LinkedList;

public class EntryProcessorExample {
    public EntryProcessorExample() {
    }

    public static void main(String[] args) {
        
        NamedCache person = CacheFactory.getCache("person");
        LinkedList peopleList = new LinkedList();
        
        // build the list
        peopleList.add( new Person(1,"Flinstone","Fred","Address",29,Person.MALE));
        peopleList.add( new Person(2,"Flinstone","Wilma","Address",29,Person.FEMALE));
        peopleList.add( new Person(3,"Rubble","Barney","Address",44,Person.MALE));
        peopleList.add( new Person(4,"Rubble","Betty","Address",44,Person.FEMALE));
        peopleList.add( new Person(5,"Rubble","Dino","Address",44,Person.FEMALE));
        
        for (java.util.Iterator iterator = peopleList.iterator(); iterator.hasNext();) {
                
                Person p = (Person)iterator.next();
                person.put(p.getKey(), p);            
        }
        
        // now run the entry processor to display where they are!
        person.invokeAll(AlwaysFilter.INSTANCE, new WhereAreYouProcessor());
    }
}
